;;****************************************************************************************
;; CALCL.LSP v.1.1
;;  AutoCAD 200X for Windows
;;
;; 17.03.2002
;;
;;  :       
;; LINE, ARC  CIRCLE   (   )    
;;     
;;
;; ,     
;;   POLYLINE,      
;;    LINE  ARC
;;
;;  ,    CALCL.LSP
;;      Load Applications ( 兔)
;;   Tools ()     :
;; Command: appload
;;
;;     :
;; Command: CALCL
;;
;;         .
;;          .
;;          
;;    ,    .
;;    ,      .
;;       兔
;;
;;    1.1     1.0:
;; 1.       LengCalc,
;;       AutoLisp 
;; Copyright, 2002  
;; E-Mail: nest@mail.ru
;; http://nestcad.da.ru 
;;***************************************************************************************
;;   
(defun LengCalc	(Nab / Nab Curve Param Len)
  (if Nab
    (progn
      (vl-load-com)
	(setq Curve (vlax-ename->vla-object Nab)
	      Param (vl-catch-all-apply
		      'vlax-Curve-getEndParam
		      (list Curve)
		    )
	)
	(if (not (vl-catch-all-error-p Param))
	  (setq Len (vlax-curve-getDistAtParam Curve Param))
	)
    )
  )
  (setq Len Len)
)

;; 
(defun C:CALCL (/ ss cnt lay laylst base_p length_cnt length_line length_arc length_circle sp ep r sa ea)
  (setq length_line 0)
  (setq length_arc 0)
  (setq length_circle 0)

  ;; 
  (prompt
    "\n         : "
  )
  (setq ss (ssget))

  (if ss
    (progn
      
      ;;   
      (setq cnt 0)
      (while (and ss
		  (> (sslength ss) 0)
		  (setq lay (ssname ss cnt))
	     ) ;_and
	(setq lay (cdr (assoc 8 (entget lay))))
	(if (not (member lay laylst))
	  (setq laylst (cons lay laylst))
	)
	(setq cnt (1+ cnt))
      ) ;_while

      ;;  
      (setq ss (ssget "_X" '((0 . "INSERT"))))
      (if ss
	(progn
	  (setq cnt 0)
	  (while
	    (and ss
		 (> (sslength ss) 0)
		 (< cnt (sslength ss))
		 (setq lay
			(cdr (assoc 8 (setq base_p (entget (ssname ss cnt))))
			)
		 )
	    ) ;_and
	     (if (member lay laylst) ;_      
	       (progn
		 (command "_explode" (ssname ss cnt))
	       ) ;_progn
	     ) ;_if
	     (setq cnt (1+ cnt))
	  ) ;_while
	) ;_progn
      ) ;_if

      ;;  
      (setq ss (ssget "_X" '((0 . "LWPOLYLINE"))))
      (if ss
	(progn
	  (setq cnt 0)
	  (while
	    (and ss
		 (> (sslength ss) 0)
		 (< cnt (sslength ss))
		 (setq lay
			(cdr (assoc 8 (setq base_p (entget (ssname ss cnt))))
			)
		 )
	    ) ;_and
	     (if (member lay laylst) ;_      
	       (progn
		 (command "_explode" (ssname ss cnt))
	       ) ;_progn
	     ) ;_if
	     (setq cnt (1+ cnt))
	  ) ;_while
	) ;_progn
      ) ;_if

      ;;  
      (setq ss (ssget "_X" '((0 . "LINE"))))
      (if ss
	(progn
	  (setq cnt 0)
	  (while
	    (and ss
		 (> (sslength ss) 0)
		 (< cnt (sslength ss))
		 (setq lay
			(cdr (assoc 8 (setq base_p (entget (ssname ss cnt))))
			)
		 )
	    ) ;_and
	     (if (member lay laylst) ;_      
	       (progn
		 (setq length_cnt (LengCalc (ssname ss cnt)))
		 (setq length_line (+ length_line length_cnt))
	       ) ;_progn
	     ) ;_if
	     (setq cnt (1+ cnt))
	  ) ;_while
	  (princ
	    (strcat
	      "\n     LINE   :"
	      (rtos length_line 2 3)
	    )
	  )
	) ;_progn
      ) ;_if

      ;;  
      (setq ss (ssget "_X" '((0 . "ARC"))))
      (if ss
	(progn
	  (setq cnt 0)
	  (while
	    (and ss
		 (> (sslength ss) 0)
		 (< cnt (sslength ss))
		 (setq lay
			(cdr (assoc 8 (setq base_p (entget (ssname ss cnt))))
			)
		 )
	    ) ;_and
	     (if (member lay laylst) ;_      
	       (progn
		 (setq length_cnt (LengCalc (ssname ss cnt)))
		 (setq length_arc (+ length_arc length_cnt))
	       ) ;_progn
	     ) ;_if
	     (setq cnt (1+ cnt))
	  ) ;_while
	  (princ
	    (strcat
	      "\n     ARC   :"
	      (rtos length_arc 2 3)
	    )
	  )
	) ;_progn
      ) ;_if

      ;;  
      (setq ss (ssget "_X" '((0 . "CIRCLE"))))
      (if ss
	(progn
	  (setq cnt 0)
	  (while
	    (and ss
		 (> (sslength ss) 0)
		 (< cnt (sslength ss))
		 (setq lay
			(cdr (assoc 8 (setq base_p (entget (ssname ss cnt))))
			)
		 )
	    ) ;_and
	     (if (member lay laylst) ;_      
	       (progn
		 (setq length_cnt (LengCalc (ssname ss cnt)))
		 (setq length_circle (+ length_circle length_cnt))
	       ) ;_progn
	     ) ;_if
	     (setq cnt (1+ cnt))
	  ) ;_while
	  (princ
	    (strcat
	      "\n     CIRCLE   :"
	      (rtos length_circle 2 3)
	    )
	  )
	) ;_progn
      ) ;_if

    ) ;_progn
  ) ;_if
  (princ)
)


